; ##################
; # Public Aliases #
; ##################

; # /nsetup
; # ffnet den Setup-Dialog
; #########################

#_dns.command on
alias nsetup {
  if ($isid) return
  _dns.dialog $1-
}
#_dns.command end

; # /autojoin
; # Betritt die eingestellten Kanle fr das aktive Netzwerk
; ##########################################################

#_dns.command.autojoin on
alias autojoin {
  if ($isid) return
  _dns.autojoin $1-
}
#_dns.command.autojoin end

; ###################
; # Interne Aliases #
; ###################

alias -l _dns.version return 0.7.1
; # /_dns.autojoin
; # Betritt die eingestellten Kanle fr das aktive Netzwerk
; ##########################################################

alias -l _dns.autojoin {
  var %chans,%network = $_dns.network,%i = 1
  if ($istok($hget(_dns,network),%network,32)) %chans = $hget(_dns,$+(%network,_chan))
  else %chans = $hget(_dns,chan)
  var %j = $numtok(%chans,32)
  while (%i <= %j) {
    join $replace($gettok(%chans,%i,32),$chr(58),$chr(32))
    inc %i
  }
}

; # /_dns.aautojoin
; # Verzgert, falls eingestellt, den Autojoin
; ############################################

alias -l _dns.aautojoin {
  var %delay,%delaysecs
  if ($istok($hget(_dns,network),$_dns.network,32)) {
    %delay = $hget(_dns,$+($_dns.network,_Delay))
    %delaysecs = $hget(_dns,$+($_dns.network,_Delaysecs))
  }
  else {
    %delay = $hget(_dns,Delay)
    %delaysecs = $hget(_dns,Delaysecs)
  }
  if (%delay == 1) && (%delaysecs isnum) .timer 1 %delaysecs _dns.autojoin
  else _dns.autojoin
}

; # /_dns.automode
; # Setzt die eingestellten ConnectModes fr das aktive Netzwerk
; ##############################################################

alias -l _dns.automode {
  var %modes
  if ($istok($hget(_dns,network),$_dns.network,32)) %modes = $hget(_dns,$+($_dns.network,_ConnectMode))
  else %modes = $hget(_dns,ConnectMode)
  if (%modes) mode $me %modes
}

; # /_dns.autoopermode
; # Setzt die eingestellten OperModes fr das aktive Netzwerk
; ###########################################################

alias -l _dns.autoopermode {
  var %modes
  if ($istok($hget(_dns,network),$_dns.network,32)) %modes = $hget(_dns,$+($_dns.network,_OperMode))
  else %modes = $hget(_dns,OperMode)
  if (%modes) mode $me %modes
}

; # /_dns.autooper
; # Fhrt /oper mit den eingestellten Parametern aus
; ##################################################

alias -l _dns.autooper {
  var %oper
  if ($istok($hget(_dns,network),$_dns.network,32)) %oper = $hget(_dns,$+($_dns.network,_ConnectOper))
  else %oper = $hget(_dns,ConnectOper)
  if (%oper) oper %oper
}

; # /_dns.autoident
; # Identifiziert den aktuellen Nick bei den Services
; ###################################################

alias -l _dns.autoident {
  if ($istok($hget(_dns,network),$_dns.network,32)) var %pass = $hget(_dns,$+($_dns.network,_IdentNicks))
  else var %pass = $hget(_dns,IdentNicks)
  if (%pass) _dns.ident %pass
}
alias -l _dns.ident {
  if ($_dns.network == QuakeNet) {
    var %user = $gettok($gettok($1-,1,32),1,58)
    var %pass = $gettok($gettok($1-,1,32),2,58)
    !.msg Q@CServe.quakenet.org auth %user %pass
  }
  else {
    var %pass = $gettok($wildtok($1-,$+($me,:*),1,32),2,58)
    !.nickserv identify %pass
  }
}

; # /_dns.autoperform
; # Fhrt die Perform-Kommandos fr das aktive Netzwerk aus
; #########################################################

alias -l _dns.autoperform {
  var %file
  if ($istok($hget(_dns,network),$_dns.network,32)) %file = $_dns.sfile($+(perform\,$_dns.network,_perform))
  else %file = $_dns.sfile(perform\perform)
  if ($isfile(%file)) .play -c status %file 0
}

; # /_dns.dialog
; # ffnet den Setup-Dialog
; #########################

alias -l _dns.dialog {
  if ($dialog(_dns.setup)) dialog -v _dns.setup
  else dialog -m _dns.setup _dns.setup
  if ($1) && ($istok($hget(_dns,network),$1,32)) {
    did -c _dns.setup 2 $didwm(_dns.setup,2,$1)
    _dns.setup.tempload $1
  }
}

; # $_dns.sfile(file.ext)
; # Gibt Dateipfad zurck fr Datei in Script-Verzeichnis
; # Format: "x:\path\file.ext
; #######################################################

alias -l _dns.sfile {
  if ($version > 5.9) return $+(",$scriptdir,$1-,")
  else return [ " $+ [ $scriptdir ] $+ [ $1- ] $+ " ]
}

; # $_dns.user
; # Gibt user32.dll oder user.exe zurck Abhngig vom OS
; ######################################################

alias -l _dns.user {
  if ($istok(XP 2K,$os,32)) return user32.dll
  else return user.exe
}

; # $_dns.network
; # Erweitert $network
; ####################

alias _dns.network {
  if ($network) && (*.ChatNet.Org !iswm $server) && ($network != ETG) return $network
  else {
    if (*.ChatNet.Org iswm $server) return ChatNet
    elseif ($network == ETG) return EnterTheGame
    elseif (*.*.quakenet.eu.org iswm $server) return QuakeNet
    elseif (*.funchat.net iswm $server) return FunChat.Net
    elseif (*.ca.us.webchat.org iswm $server) return WebChat
    elseif (*.galaxynet.org iswm $server) return GalaxyNet
    elseif ($istok($_efnet,$server,32)) return EFnet
    elseif ($istok($_linknet,$server,32)) return LinkNet
    elseif (*.GamesNET.net iswm $server) return GamesNET
    elseif ($istok($_ircnet,$server,32)) return IRCnet
  }
}
alias -l _efnet { return irc.homelien.no irc.hub.uk irc.du.se efnet.demon.co.uk irc.light.se irc.rt.ru irc.hemmet.chalmers.se irc.efnet.pl efnet.vuurwerk.nl irc.ins.net.uk irc.carrier1.net.uk irc.exodus.net ircd.lightning.net irc.lightning.net irc.mindspring.com *.umich.edu irc.Prison.NET irc.solidstreaming.net irc-h.total.net irc2.magic.ca irc.etsmtl.ca irc.magic.ca irc-h.powersurfr.com irc.powersurfr.com irc.plur.net ircd.east.gblx.net irc.nijenrode.nl irc.east.gblx.net *.concentric.net services.us *.umn.edu irc.emory.edu irc.colorado.edu *.stanford.edu *.lagged.org irc.mcs.net irc-h.magic.ca irc.isdnet.fr irc.gigabell.de hub.il irc.inter.net.il efnet.cs.hut.fi }
alias -l _linknet { return irc.panthar.net irc.sh.cvut.cz irc.securebsd.de irc.isecomm.com irc.link-net.nl irc.no.link-net.org irc.fliphead.com irc.gamiix.com irc.mirkwarriors.net irc.orkan.net irc.glassbilen.net irc-c.netfire.com irc.c-com.org irc.kinexuseurope.co.uk }
alias -l _ircnet { return irc.fr.ircnet.net irc.ircd.it ircnet.netvision.net.il irc.tokyo.wide.ad.jp irc.seed.net.tw linz.irc.at vienna.irc.at irc.belnet.be ircnet.wanadoo.be irc.felk.cvut.cz irc.fu-berlin.de irc.freenet.de irc.belwue.de irc.ircnet.dk irc.estpak.ee irc.cs.hut.fi irc.ee.auth.gr irc.elte.hu irc.ircnet.is irc.simnet.is irc.tin.it irc.nl.uu.net irc.xs4all.nl irc.snt.utwente.nl irc.sci.kun.nl irc.ifi.uio.no irc.pvv.ntnu.no lublin.irc.pl warszawa.irc.pl irc.msu.ru irc.ludd.luth.se ircnet.demon.co.uk ircnet.easynet.co.uk irc.stealth.net BelWue.DE freenet.de }

; # /_dns.setup.tempsave
; # Speichert aktuelle Einstellungen des Setup-Dialogs
; # in temporrer Hash-Table ab.
; ####################################################

alias -l _dns.setup.tempsave {
  var %_dns.chan = $did(_dns.setup,6).lines,%i = 1,%_dns.chans,%j = 1,%_dns.network = $did(_dns.setup,2).lines,%_dns.networks,%_dns.prefix = $iif($did(_dns.setup,2).seltext != --Default--,$+($did(_dns.setup,2).seltext,_)),%_dns.ident = $did(_dns.setup,28).lines,%_dns.idents,%k = 1
  while (%i <= %_dns.chan) {
    %_dns.chans = %_dns.chans $did(_dns.setup,6,%i).text
    inc %i
  }
  while (%j <= %_dns.network) {
    %_dns.networks = %_dns.networks $did(_dns.setup,2,%j).text
    inc %j
  }
  while (%k <= %_dns.ident) {
    %_dns.idents = %_dns.idents $did(_dns.setup,28,%k).text
    inc %k
  }
  if (!$hget(_dns.temp)) hmake _dns.temp $calc(16 * $did(_dns.setup,2).lines)
  hadd _dns.temp $+(%_dns.prefix,chan) %_dns.chans
  hadd _dns.temp $+(%_dns.prefix,autojoin) $did(_dns.setup,12).state
  hadd _dns.temp $+(%_dns.prefix,ConnectSetMode) $did(_dns.setup,14).state
  hadd _dns.temp $+(%_dns.prefix,OperSetMode) $did(_dns.setup,17).state
  hadd _dns.temp $+(%_dns.prefix,ConnectSetOper) $did(_dns.setup,19).state
  hadd _dns.temp $+(%_dns.prefix,RegainNick) $did(_dns.setup,24).state
  hadd _dns.temp $+(%_dns.prefix,Perform) $did(_dns.setup,34).state
  hadd _dns.temp $+(%_dns.prefix,ConnectMode) $did(_dns.setup,16)
  hadd _dns.temp $+(%_dns.prefix,OperMode) $did(_dns.setup,18)
  hadd _dns.temp $+(%_dns.prefix,ConnectOper) $did(_dns.setup,20)
  hadd _dns.temp $+(%_dns.prefix,PermNick) $did(_dns.setup,25)
  hadd _dns.temp $+(%_dns.prefix,AutoIdent) $did(_dns.setup,27).state
  hadd _dns.temp $+(%_dns.prefix,IdentNicks) %_dns.idents
  hadd _dns.temp network $remtok(%_dns.networks,--Default--,32)
  hadd _dns.temp $+(%_dns.prefix,Delay) $did(_dns.setup,36).state
  hadd _dns.temp $+(%_dns.prefix,Delaysecs) $did(_dns.setup,37)
  savebuf -o _dns.setup 35 $_dns.sfile($+(perform\temp,%_dns.prefix,perform))
}

; # /_dns.setup.tempload network
; # Ldt Einstellungen aus temporrer Hash-Table fr
; # angegebenes Netzwerk in den Setup-Dialog.
; ##################################################

alias -l _dns.setup.tempload {
  var %_dns.prefix = $iif($1 != --Default--,$+($1,_)),%_dns.chans = $hget(_dns.temp,$+(%_dns.prefix,chan)),%j = $numtok(%_dns.chans,32),%i = 1,%_dns.idents = $hget(_dns.temp,$+(%_dns.prefix,IdentNicks)),%k = $numtok(%_dns.idents,32),%l = 1,%m = 1,%line,%win
  did -r _dns.setup 6,16,18,20,25,28,35,37
  did -u _dns.setup 12,14,17,19,24,27,34,36
  while (%i <= %j) {
    did -a _dns.setup 6 $gettok(%_dns.chans,%i,32)
    inc %i
  }
  while (%l <= %k) {
    did -a _dns.setup 28 $gettok(%_dns.idents,%l,32)
    inc %l
  }
  if ($hget(_dns.temp,$+(%_dns.prefix,autojoin)) == 1) did -c _dns.setup 12
  if ($hget(_dns.temp,$+(%_dns.prefix,ConnectSetMode)) == 1) did -c _dns.setup 14
  if ($hget(_dns.temp,$+(%_dns.prefix,OperSetMode)) == 1) did -c _dns.setup 17
  if ($hget(_dns.temp,$+(%_dns.prefix,ConnectSetOper)) == 1) did -c _dns.setup 19
  if ($hget(_dns.temp,$+(%_dns.prefix,RegainNick)) == 1) did -c _dns.setup 24
  if ($hget(_dns.temp,$+(%_dns.prefix,AutoIdent)) == 1) did -c _dns.setup 27
  if ($hget(_dns.temp,$+(%_dns.prefix,Perform)) == 1) did -c _dns.setup 34
  if ($hget(_dns.temp,$+(%_dns.prefix,Delay)) == 1) did -c _dns.setup 36
  did -a _dns.setup 16 $hget(_dns.temp,$+(%_dns.prefix,ConnectMode))
  did -a _dns.setup 18 $hget(_dns.temp,$+(%_dns.prefix,OperMode))
  did -a _dns.setup 20 $hget(_dns.temp,$+(%_dns.prefix,ConnectOper))
  did -a _dns.setup 25 $hget(_dns.temp,$+(%_dns.prefix,PermNick))
  did -a _dns.setup 37 $hget(_dns.temp,$+(%_dns.prefix,Delaysecs))
  %win = @__loadperform
  close -@ %win
  window -hls %win
  if ($isfile($_dns.sfile($+(perform\temp,%_dns.prefix,perform)))) loadbuf %win $_dns.sfile($+(perform\temp,%_dns.prefix,perform))
  elseif ($isfile($_dns.sfile($+(perform\,%_dns.prefix,perform)))) loadbuf %win $_dns.sfile($+(perform\,%_dns.prefix,perform))
  while (%m <= $line(%win,0)) {
    %line = $line(%win,%m)
    if ((%line) && (%line != $chr(32))) did -a _dns.setup 35 %line $+ $crlf
    inc %m
  }
  close -@ %win
}

; ##########
; # Popups #
; ##########

menu menubar {
  &Network Setup
  .&Setup:_dns.dialog
  .&Unload:.unload -rs $nopath($script)
}

; ##########
; # Remote #
; ##########

; # Beim Starten
; # Public Aliases nur aktivieren, falls nicht durch anderes
; # Script genutzt.
; # Einstellungen in Hash-Table laden
; ###########################################################

on *:start: {
  .disable #_dns.command
  if (!$isalias(nsetup)) .enable #_dns.command
  .disable #_dns.command.autojoin
  if (!$isalias(autojoin)) .enable #_dns.command.autojoin
  if ($hget(_dns)) hfree _dns
  hmake _dns 10
  if ($isfile($_dns.sfile(nsetup.hsh))) hload _dns $_dns.sfile(nsetup.hsh)
}

; # Sobald Verbindung besteht
; # AutoJoin aktiv? -> /_dns.autojoin
; # Mode on COnnect aktiv? -> /_dns.automode
; # /oper aktiv? -> /_dns.autooper
; # Perform aktiv? -> /_dns.autoperform
; ##########################################

on *:connect: {
  if ($istok($hget(_dns,network),$_dns.network,32)) {
    if ($hget(_dns,$+($_dns.network,_autojoin)) == 1) _dns.aautojoin
    if ($hget(_dns,$+($_dns.network,_ConnectSetMode)) == 1) _dns.automode
    if ($hget(_dns,$+($_dns.network,_ConnectSetOper)) == 1) _dns.autooper
    if ($hget(_dns,$+($_dns.network,_Perform)) == 1) _dns.autoperform
    if ($hget(_dns,$+($_dns.network,_AutoIdent)) == 1) && (!$istok(PhatNET German-Elite,$_dns.network,32)) _dns.autoident
  }
  else {
    if ($hget(_dns,autojoin) == 1) _dns.aautojoin
    if ($hget(_dns,ConnectSetMode) == 1) _dns.automode
    if ($hget(_dns,ConnectSetOper) == 1) _dns.autooper
    if ($hget(_dns,Perform) == 1) _dns.autoperform
    if ($hget(_dns,AutoIdent) == 1) && (!$istok(PhatNET German-Elite,$_dns.network,32)) _dns.autoident
  }
}

; # Sobald Operator-Status vergeben ist
; # Falls Mode On Oper aktiv, fhre /_dns.autoopermode aus
; ########################################################

raw 381:*: {
  if ($istok($hget(_dns,network),$_dns.network,32)) {
    if ($hget(_dns,$+($_dns.network,_OperSetMode)) == 1) _dns.autoopermode
  }
  else {
    if ($hget(_dns,OperSetMode) == 1) _dns.autoopermode
  }
}

; # Sobald Notice von NickServ kommt,
; # den Nick zu identifizieren
; # /_dns.autoident ausfhren
; # getestete Netzwerke:
; # German-Elite (german), PhatNET (english)
; ##########################################

on *:notice:*:?: {
  if ($nick == NickServ) && ($_dns.network != QuakeNet) {
    if (This nickname is registered and protected. If it is your == $1-) || $&
      (Dieser Nickname ist registriert and geschtzt. Wenn es dein Nick == $1-) || $&
      (This nick is owned by someone else. Please choose another. == $1-) {
      if ($istok($hget(_dns,network),$_dns.network,32)) {
        if ($hget(_dns,$+($_dns.network,_AutoIdent)) == 1) _dns.autoident
      }
      else {
        if ($hget(_dns,AutoIdent) == 1) _dns.autoident
      }
    }
  }
}

on me:*:nick: {
  if (!$istok(PhatNET German-Elite QuakeNet,$_dns.network,32)) {
    if ($istok($hget(_dns,network),$_dns.network,32)) {
      if ($hget(_dns,$+($_dns.network,_AutoIdent)) == 1) _dns.autoident
    }
    else {
      if ($hget(_dns,AutoIdent) == 1) _dns.autoident
    }
  }
}

on *:unload:{
  var %t = $input(Are you sure you want to completely remove this script and all of its components? $crlf "No" will just unload the script and leaves all settings and files unchanged.,yq,Confirm File deletion)
  echo $color(i) -es Unload Defcon Network Setup v $+ $_dns.version
  if (%t == $false) halt
  if ($dialog(_dns.networkadd)) || ($dialog(_dns.channeladd)) || ($dialog(_dns.identadd)) || ($dialog(_dns.channeledit)) || ($dialog(_dns.identedit)) || ($dialog(_dns.setup)) {
    echo $color(i) -s Close Dialogs
    var %i 1
    while ($gettok(_dns.networkadd _dns.channeladd _dns.identadd _dns.channeledit _dns.identedit _dns.setup,%i,32)) {
      if ($dialog($ifmatch)) dialog -x $ifmatch
      inc %i
    }
  }
  if ($hget(_dns)) {
    echo $color(i) -s Free all existing hash tables.
    if ($hget(_dns)) hfree _dns
  }
  var %i 1,%j $calc($numtok($_dns.filelist,32) / 2)
  while (%i <= %j) {
    if ($isfile($+(",$scriptdir,$token($_dns.filelist,%i,32),"))) {
      echo $color(i) -s Remove $token($_dns.filelist,$calc(%i + 3),32) $+(",$scriptdir,$token($_dns.filelist,%i,32),")
      .remove -b $+(",$shortfn($scriptdir),$token($_dns.filelist,%i,32),")
    }
    inc %i
  }
  echo $color(i) -es Finished Unloading Defcon Nickcompleter v $+ $_dns.version
}
alias -l _dns.filelist return nsetup.hsh nsetup-readme.txt getdir.dll Settings-File Documentation Dynamic-Link-Library


; ###########
; # Dialogs #
; ###########

; # Setup-Dalog Table
; ###################

dialog -l _dns.setup {
  title "Network Setup [/nsetup]"
  size -1 -1 165 180
  option dbu
  box "Network", 1, 5 5 155 30
  combo 2, 10 16 60 50, size drop
  button "A&dd", 3, 75 15 37 12
  button "Re&move", 4, 117 15 37 12
  tab "Au&tojoin", 5, 5 40 155 120
  button "&Add", 7, 118 65 37 12, tab 5
  button "&Remove", 8, 118 80 37 12, tab 5
  button "&Edit", 9, 118 95 37 12, tab 5
  check "&Join this Channels on connect", 12, 10 55 90 10, tab 5
  list 6, 10 65 103 75, tab 5 size vsbar
  button "&Up", 21, 118 110 37 12, tab 5
  button "&Down", 22, 118 125 37 12, tab 5
  check "Delay Autojoin", 36, 10 145 50 10, tab 5
  edit "", 37, 60 145 15 10, tab 5
  text "seconds after connect", 38, 80 147 60 8, tab 5
  tab "Modes/Misc", 13
  check "&Set on Connect", 14, 15 66 50 10, tab 13
  box "Modes", 15, 10 56 145 45, tab 13
  edit "", 16, 65 66 85 10, tab 13
  check "S&et on Oper", 17, 15 76 50 10, tab 13
  edit "", 18, 65 76 85 10, tab 13
  check "/o&per", 19, 15 86 50 10, tab 13
  edit "", 20, 65 86 85 10, tab 13
  box "Misc", 23, 10 105 145 25, disable tab 13
  check "Regain Perm Nick", 24, 15 115 60 10, disable tab 13
  edit "", 25, 75 115 75 10, disable tab 13
  tab "Auto Identify", 26
  check "Identify this Nicks automatically", 27, 10 55 95 10, tab 26
  list 28, 10 65 103 90, tab 26 size vsbar
  button "&Add", 29, 118 65 37 12, tab 26
  button "&Remove", 30, 118 80 37 12, tab 26
  button "&Edit", 32, 118 95 37 12, tab 26
  tab "Perform", 33
  check "On Connect, perform these commands", 34, 10 55 110 10, tab 33
  edit "", 35, 10 65 145 90, tab 33 multi return autohs autovs hsbar vsbar
  button "&OK", 10, 81 165 37 12, ok
  button "&Cancel", 11, 123 165 37 12, cancel
  text "", 31, 5 169 70 8
}

; # Input-Dialog Table
; # Wird fr versch. Eingaben verwendet
; #####################################

dialog -l _dns.input {
  title ""
  size -1 -1 145 52
  option dbu
  text "", 1, 30 5 110 13
  edit "", 2, 30 20 110 10, hide result autohs disable
  button "&OK", 3, 45 35 37 12, ok default
  button "&Cancel", 4, 88 35 37 12, cancel
  icon 5, 5 5 16 16
  combo 6, 30 20 110 50, disable hide sort size edit drop
}

; #################
; # Dialog Events #
; #################

; # Init-Events fr Input-Dialoge
; # Texte, Titel und Art der Eingabemglichkeit festlegen.
; # Teilweise verden Vorschlge fr Eingabe generiert.
; ########################################################

on *:dialog:_dns.networkadd:init:0: {
  var %_dns.networks,%i = 1,%j = $scon(0)
  while (%i <= %j) {
    scid $scon(%i)
    %_dns.networks = %_dns.networks $_dns.network
    inc %i
  }
  if (%_dns.networks) { did -a _dns.networkadd 1 Enter Network $+ $crlf $+ [Connections: %_dns.networks $+ ] }
  else { did -a _dns.networkadd 1 Enter Network $+ $crlf $+ [One Word Please] }
  dialog -t _dns.networkadd Network Setup: Add Network
  did -evf _dns.networkadd 2
  did -g _dns.networkadd 5 2 $+($gettok($dll($_dns.sfile(getdir.dll),GetDir,System),2-,32),\,$_dns.user)
}
on *:dialog:_dns.channeladd:init:0: {
  var %_dns.chan = $chan(0)
  did -a _dns.channeladd 1 Enter Channels, separated by space $+ $crlf $+ [Format: #chan:pass]
  did -g _dns.channeladd 5 2 $+($gettok($dll($_dns.sfile(getdir.dll),GetDir,System),2-,32),\,$_dns.user)
  dialog -t _dns.channeladd Network Setup: Add Channel
  did -evf _dns.channeladd 6
  while (%_dns.chan > 0) {
    did -a _dns.channeladd 6 $chan(%_dns.chan) $+ $iif($chan(%_dns.chan).key,$+(:,$chan(%_dns.chan).key))
    dec %_dns.chan
  }
}
on *:dialog:_dns.identadd:init:0: {
  did -a _dns.identadd 1 Enter Nicks, seperated by space $+ $crlf $+ [Format: nick:pass]
  did -g _dns.identadd 5 2 $+($gettok($dll($_dns.sfile(getdir.dll),GetDir,System),2-,32),\,$_dns.user)
  dialog -t _dns.identadd Network Setup: Add AutoIdent-Nick
  did -aevf _dns.identadd 2 $scid($activecid).me
}
on *:dialog:_dns.channeledit:init:0: {
  did -a _dns.channeledit 1 Edit Channelname/Password $+ $crlf $+ [Format: #chan:pass]
  did -g _dns.channeledit 5 2 $+($gettok($dll($_dns.sfile(getdir.dll),GetDir,System),2-,32),\,$_dns.user)
  dialog -t _dns.channeledit Network Setup: Edit Channel
  did -aevf _dns.channeledit 2 $did(_dns.setup,6).seltext
}
on *:dialog:_dns.identedit:init:0: {
  did -a _dns.identedit 1 Edit Nickname/Password $+ $crlf $+ [Format: nick:pass]
  did -g _dns.identedit 5 2 $+($gettok($dll($_dns.sfile(getdir.dll),GetDir,System),2-,32),\,$_dns.user)
  dialog -t _dns.identedit Network Setup: Edit AutoIdent-Nick
  did -aevf _dns.identedit 2 $did(_dns.setup,28).seltext
}

; # bertrage Resultat bei OK
; ###########################

on *:dialog:_dns.channeladd:sclick:3: {
  did -a _dns.channeladd 2 $did(6)
}

; # Setup-Dialog Events
; #####################

on *:dialog:_dns.setup:init:0: {
  if ($group(#_dns.command) != on) dialog -t _dns.setup Network Setup
  if ($hget(_dns.temp)) hfree _dns.temp
  hmake _dns.temp 10
  if ($isfile($_dns.sfile(nsetup.hsh))) hload _dns.temp $_dns.sfile(nsetup.hsh)

  did -a _dns.setup 2 --Default--
  did -c _dns.setup 2 1

  var %_dns.networks = $hget(_dns.temp,network),%k = 1,%l = $numtok(%_dns.networks,32)
  while (%k <= %l) {
    did -a _dns.setup 2 $gettok(%_dns.networks,%k,32)
    inc %k
  }
  _dns.setup.tempload --Default--
  did -o _dns.setup 31 1 version: $_dns.version
}
on *:dialog:_dns.setup:sclick:2: {
  ; Change Network
  _dns.setup.tempload $did(2).seltext
}
on *:dialog:_dns.setup:sclick:3: {
  ; Add Network
  var %_dns.temp = $dialog(_dns.networkadd,_dns.input,-4),%_dns.tmp
  if (%_dns.temp) {
    if ($regex(%_dns.temp,^[a-zA-Z0-9\.\-]*$)) did -a _dns.setup 2 %_dns.temp
    else {
      if ($chr(32) isin %_dns.temp) %_dns.tmp = $input(Error: You cannot use spaces in the network name.,516,Network Setup: Error)
      else %_dns.tmp = $input(Error: You cannot use special characters in the network name.,516,Network Setup: Error)
    }
  }
  _dns.setup.tempsave
}
on *:dialog:_dns.setup:sclick:4: {
  ; Remove Network
  if ($did(2).seltext != --Default--) {
    hdel -w _dns.temp $+($did(2).seltext,_*)
    did -d _dns.setup 2 $did(2).sel
    did -c _dns.setup 2 1
    _dns.setup.tempload $did(2).seltext
  }
  else var %_dns.tmp = $input(Error: You cannot remove the defaults.,516,Network Setup: Error)
}
on *:dialog:_dns.setup:sclick:7: {
  ; Add Channel
  scid $activecid
  var %_dns.temp = $dialog(_dns.channeladd,_dns.input,-4),%i = 1,%j = $numtok(%_dns.temp,32),%add,%fail,%_dns.tmp,%msg
  if (%_dns.temp) {
    while (%i <= %j) {
      %add = $gettok(%_dns.temp,%i,32)
      if ($didwm(_dns.setup,6,%add) == 0) did -a _dns.setup 6 %add
      else %fail = %fail %add
      inc %i
    }
    if (%fail) {
      %msg = The following entries already existed and were not added again:
      %i = $numtok(%fail,32)
      while (%i) {
        %msg = %msg $+ $crlf $+ $gettok(%fail,%i,32)
        dec %i
      }
      %_dns.tmp = $input(%msg,68,Network Setup: Information)
    }
  }
  _dns.setup.tempsave
}
on *:dialog:_dns.setup:sclick:8: {
  ; Remove Channel
  if ($did(6).sel) {
    did -d _dns.setup 6 $did(6).sel
    _dns.setup.tempsave
  }
}
on *:dialog:_dns.setup:sclick:9: {
  ; Edit Channel
  if ($did(6).sel) {
    var %_dns.temp = $dialog(_dns.channeledit,_dns.input,-4)
    if (%_dns.temp) { did -o _dns.setup 6 $did(6).sel %_dns.temp }
    _dns.setup.tempsave
  }
}
on *:dialog:_dns.setup:sclick:10: {
  ; OK
  _dns.setup.tempsave
  hsave -o _dns.temp $_dns.sfile(nsetup.hsh)
  if ($hget(_dns)) hfree _dns
  hmake _dns 10
  hload _dns $_dns.sfile(nsetup.hsh)
  var %tmp = $findfile($_dns.sfile(perform\),temp*perform,0,1,.copy -o $+(",$1-,") $+(",$nofile($1-),$right($nopath($1-),-4),"))
  var %tmp = $findfile($_dns.sfile(perform\),temp*perform,0,1,.remove $+(",$1-,"))
}
on *:dialog:_dns.setup:sclick:11: {
  var %tmp = $findfile($_dns.sfile(perform\),temp*perform,0,1,.remove $+(",$1-,"))
}
on *:dialog:_dns.setup:sclick:12: {
  ; Tempsave
  _dns.setup.tempsave
  did -f _dns.setup 6
}
on *:dialog:_dns.setup:sclick:14,17,19,24,27,34,36: _dns.setup.tempsave
on *:dialog:_dns.setup:edit:16,18,20,25,35,37: _dns.setup.tempsave
on *:dialog:_dns.setup:sclick:21: {
  ; Autojoin Channel Up
  var %line1 = $did(6).seltext,%line2 = $did(6,$calc($did(6).sel - 1)),%sel = $did(6).sel
  if (%sel > 1) {
    did -o _dns.setup 6 %sel %line2
    did -co _dns.setup 6 $calc(%sel - 1) %line1
    _dns.setup.tempsave
  }
}
on *:dialog:_dns.setup:sclick:22: {
  ; Autojoin Channel Down
  var %line1 = $did(6).seltext,%line2 = $did(6,$calc($did(6).sel + 1)),%sel = $did(6).sel
  if (%sel < $did(6).lines) {
    did -o _dns.setup 6 %sel %line2
    did -co _dns.setup 6 $calc(%sel + 1) %line1
    _dns.setup.tempsave
  }
}
on *:dialog:_dns.setup:sclick:29: {
  ; Add Auto Ident Nick
  var %_dns.temp = $dialog(_dns.identadd,_dns.input,-4),%i = 1,%j = $numtok(%_dns.temp,32),%add
  if (%_dns.temp) {
    while (%i <= %j) {
      %add = $gettok(%_dns.temp,%i,32)
      if ($didwm(_dns.setup,28,%add) == 0) did -a _dns.setup 28 %add
      inc %i
    }
  }
  _dns.setup.tempsave
}
on *:dialog:_dns.setup:sclick:30: {
  ; Remove Auto Ident Nick
  if ($did(28).sel) {
    did -d _dns.setup 28 $did(28).sel
    _dns.setup.tempsave
  }
}
on *:dialog:_dns.setup:sclick:32: {
  ; Edit Auto Ident Nick
  if ($did(28).sel) {
    var %_dns.temp = $dialog(_dns.identedit,_dns.input,-4)
    if (%_dns.temp) { did -o _dns.setup 28 $did(28).sel %_dns.temp }
    _dns.setup.tempsave
  }
}
